--[[
LootWhatIWant Addon for World of Warcraft
Original code written by Dardack
Modified by Achbed (achbed@dwbrand.net) Last on 2/6/2010
]]--

--[[

Added in selling/trash options.

]]--
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local Crayon = LibStub:GetLibrary("LibCrayon-3.0")

local version = "8.2.0a"
local commandPrefix = "/lwiw"

LootWhatIWant_GlobalBlackList = { }
LootWhatIWant = { }
LootWhatIWant.enabled = true
LootWhatIWant.blacklist = { }
LootWhatIWant.blacklistcount = { }
LootWhatIWant.dungeonLootOK = { }
LootWhatIWant.autolootWorldGroup = true
LootWhatIWant.deleteItems = false
LootWhatIWant.deleteGrays = 0
LootWhatIWant.closeLootWindow = true
LootWhatIWant.lootRarity = 2
LootWhatIWant.mouseover = false
LootWhatIWant.blacklist_GUI_linenumber = 0
LootWhatIWant.sellList_GUI_linenumber = 0
LootWhatIWant.keepList_GUI_linenumber = 0
LootWhatIWant.Inventorylist_GUI_linenumber = 0
LootWhatIWant.MobList_GUI_mobname = nil
LootWhatIWant.sellList = { }
LootWhatIWant.keepList = { }
LootWhatIWant.keepListcount = {}
LootWhatIWant.sellListcount = {}
LootWhatIWant.VendorMade = 0
LootWhatIWant.DeletedLost = 0
LootWhatIWant.SellSpamToggle = false
LootWhatIWant.toggleSellingStuff = false
LootWhatIWant.AutoLootBOA = false
LootWhatIWant.MouseClicks = false
LootWhatIWant.AutoSellAtVendor = false
LootWhatIWant.AutoCleanUpAtVendor = false
LootWhatIWant.SellBOPOveriLVL = false
LootWhatIWant.KeepBOPMaxiLVL = 0

local LootBlacklist = 0
local LootedItem = ""
local deleteAtNextBagUpdate = false
local blacklisted = false
local LootWhatIWant_Frame = CreateFrame("Frame", "LootWhatIWantFrame")
local reportNextMapUpdate = false
local LWIW_CurrentLootSlot = 0
local LWIW_SkippedBOP = false
local LWIW_ProfilesBlacklist_Placeholder
local LWIW_debugFlag = false
local LWIW_Rarity = 0
local LWIW_SellList = { }
local LWIW_SellListChecking = {}
local LWIW_GoldTotal = 0
local Broker_LWIW = LootWhatIWant_Frame
local LWIW_DisplayPlugin_MAXSTRLEN = 10
local LWIW_sellAllButton = CreateFrame("Button", "LWIW_SellItemButton", MerchantFrame)
local buttonSize = 32
local LWIW_AfterCombatUpdate = false
local LWIW_AfterBeingDeadUpdate = false
local LWIW_LootOpenedBool = false
local LWIW_TimeElapsedSinceLastBagUpdate = 0
local LWIW_ClassSpecifics = {}
local LWIW_Loaded = false
local LWIW_BOA = false
local LWIW_LockedChanged = false
--Create a tooltip to loop through gear to see if class specific
CreateFrame("GameTooltip","LootWhatIWantTooltip",UIParent,"GameTooltipTemplate")


function LWIW_CointainerOnClick(self, button)
	
	if (button == "RightButton" and IsAltKeyDown() and IsControlKeyDown()) then
		if (LootWhatIWant.MouseClicks) then
			if (LootWhatIWant.toggleSellingStuff) then
				local slot, bag = GetMouseFocus():GetID(), GetMouseFocus():GetParent():GetID()
				local info = C_Container.GetContainerItemInfo(bag, slot)
				local link = info and info.hyperlink;
				if (link ~= nil) then
					LWIW_Sell(link)
				else
					print("LWIW: You clicked an empty slot, please try again.")
				end
				return
			else
				print("LWIW: Selling options not enabled, so can't add to sell list.")
			end
		else
			print("LWIW: You have not enabled mouse clicks to sell/black list items. /lwiw mouseclicks")
		end
	end
	if (button == "LeftButton" and IsControlKeyDown() and IsAltKeyDown()) then
		if (LootWhatIWant.MouseClicks) then
			local slot, bag = GetMouseFocus():GetID(), GetMouseFocus():GetParent():GetID()
			local info = C_Container.GetContainerItemInfo(bag, slot)
			local link = info and info.hyperlink;
			if (link ~= nil) then
				LWIW_AddToBlacklist(link)
			else
				print("LWIW: You clicked an empty slot, please try again.")
			end
			return
		else
			print("LWIW: You have not enabled mouse clicks to sell/black list items. /lwiw mouseclicks")
		end
	end
end
----------------------------------------------
--Initialize the Sell all button when at a vendor
----------------------------------------------
function Broker_LWIW:OnInitialize()	
	
		LWIW_sellAllButton:SetWidth(buttonSize)
		LWIW_sellAllButton:SetHeight(buttonSize)
		local texture = LWIW_sellAllButton:CreateTexture()
		texture:SetWidth(buttonSize* 1.6458333)
		texture:SetHeight(buttonSize* 1.6458333)
		texture:SetPoint("CENTER", LWIW_sellAllButton)
		texture:SetTexture("Interface\\Buttons\\UI-Quickslot")
		LWIW_sellAllButton:SetNormalTexture(texture)
		local normalbg = LWIW_sellAllButton:CreateTexture("FOREGROUND")
		normalbg:SetTexture("Interface\\AddOns\\LootWhatIWant\\user_trash_full.tga")
		normalbg:SetWidth(buttonSize * 1.6458333)
		normalbg:SetHeight(buttonSize * 1.6458333)
		normalbg:SetAllPoints(LWIW_sellAllButton)
		normalbg:Show()
		LWIW_sellAllButton:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress")
		local texture = LWIW_sellAllButton:CreateTexture()
		texture:SetTexture("Interface\\Buttons\\ButtonHilight-Square")
		texture:SetAllPoints(LWIW_sellAllButton)
		LWIW_sellAllButton:SetHighlightTexture(texture)
		local texture = LWIW_sellAllButton:CreateTexture()
		texture:SetTexture("Interface\\Addons\\LootWhatIWant\\user_trash.tga")
		texture:SetAllPoints(LWIW_sellAllButton)
		LWIW_sellAllButton:SetDisabledTexture(texture)
		LWIW_sellAllButton:SetPoint("TOPRIGHT", MerchantFrame, "TOPRIGHT", -200, -25)
		--LWIW_sellAllButton:Show()
		LWIW_sellAllButton:SetScript("OnClick", function()
			MerchantFrameLWIW_SellAllItems()
		end)
		LWIW_sellAllButton:Enable()
		LWIW_sellAllButton:SetScript("OnEnter", function()
			MerchantLWIW_SellAllButtonOnEnter(LWIW_sellAllButton)
		end)
		LWIW_sellAllButton:SetScript("OnLeave", function()
			GameTooltip:Hide()
		end)
		local button_Enable = LWIW_sellAllButton.Enable
		function LWIW_sellAllButton:Enable()
			
			button_Enable(self)
			normalbg:Show()
		end
		local button_Disable = LWIW_sellAllButton.Disable
		function LWIW_sellAllButton:Disable()
			
			button_Disable(self)
			normalbg:Hide()
		end
		LWIW_sellAllButton:SetFrameStrata("High")
	
end

------------------------------------------------------
--Create the tooltip on the SellAllButton
------------------------------------------------------
function MerchantLWIW_SellAllButtonOnEnter(button)
	
	if (LootWhatIWant.toggleSellingStuff) then
		
		GameTooltip:SetOwner(button, "ANCHOR_RIGHT")
		GameTooltip:SetText(LWIW_SellGarItem);
		local sellValue = LWIW_GoldTotal
		GameTooltip:AddLine(LWIW_Value.." ".. (GetCoinTextureString(LWIW_GoldTotal)));
		GameTooltip:Show()
	end
end

------------------------------------------------------
--Function called when Sell All Button is Clicked
------------------------------------------------------
function MerchantFrameLWIW_SellAllItems()
	if (LootWhatIWant.toggleSellingStuff) then
		if (LootWhatIWant.VendorMade == nil) then
			LootWhatIWant.VendorMade = 0
		end
		for i = 1, #LWIW_SellList do
			if not LootWhatIWant.SellSpamToggle then
				print(LWIW_SellingVarString:format(LWIW_SellList[i][2], LWIW_SellList[i][1], (GetCoinTextureString((LWIW_SellList[i][3])))))
			end
			local info = C_Container.GetContainerItemInfo(LWIW_SellList[i][6][1], LWIW_SellList[i][6][2])
			local link = info and info.hyperlink;
			if (link ~= nil) then
				local currentItem = string.match(link, "item:(%d+)")
				--print(currentItem.." - "..LWIW_SellListChecking[currentItem])
				if (LWIW_SellListChecking[currentItem] ~= true) then
					print(LWIW_SellingError)
					return
				else
					C_Timer.After(0.5, function () C_Container.UseContainerItem(LWIW_SellList[i][6][1], LWIW_SellList[i][6][2]) end)
					LootWhatIWant.VendorMade = LootWhatIWant.VendorMade + LWIW_SellList[i][3]
					--C_Timer.After(0.2, MerchantFrameLWIW_SellAllItems)
				end
			end
		end	
		
		GameTooltip:ClearLines()
		LWIW_sellAllButton:Disable()
	end
end

------------------------------------------------------
--The ToolTip Function when hovering over LDB Plugin
------------------------------------------------------
function Broker_LWIW:Tooltip(self)
	if (LootWhatIWant.toggleSellingStuff) then
		local colNum, lineNum
	  
		Broker_LWIW.tt = LibStub("LibQTip-1.0"):Acquire("Broker_LWIWtt", 4, "LEFT", "RIGHT", "RIGHT", "CENTER")
		colNum = 4
		
		Broker_LWIW.tt:Clear()
		local tooltipHFont = CreateFont("TooltipHeaderFont")
	--	tooltipHFont:SetFont("Fonts\\FRIZQT__.TTF", 14)
		tooltipHFont:SetTextColor(1,1,1)
		
		local tooltipFont = CreateFont("TooltipFont")
	--	tooltipFont:SetFont(GameTooltipText:GetFont(), 11)
		tooltipFont:SetTextColor(255/255,176/255,25/255)
		Broker_LWIW.tt.Backdrop = CreateFrame("Frame",  "Broker_LWIW.tt.Backdrop", Broker_LWIW.tt, "BackdropTemplate")
		Broker_LWIW.tt.Backdrop:SetAllPoints()
		Broker_LWIW.tt.Backdrop.backdropInfo = {bgFile = "Interface\\Buttons\\WHITE8x8",insets = {top = 0, left = 0, bottom = 0, right = 0}}
		Broker_LWIW.tt.Backdrop:SetBackdrop(Broker_LWIW.tt.Backdrop.backdropInfo)
		--Broker_LWIW.tt:ApplyBackdrop()
		--Broker_LWIW.tt:SetBackdrop(backdropInfo) 
	    Broker_LWIW.tt:SetBackdropColor(0,0,0,.75)
		-- add header lines
		Broker_LWIW.tt:SetHeaderFont(tooltipHFont)
		Broker_LWIW.tt:AddHeader('LootWhatIWant', '', LWIW_headerRightClick)
	   
		-- add info lines
	--	Broker_LWIW.tt:SetFont(tooltipFont)
		Broker_LWIW.tt:AddLine(LWIW_headerShiftClick, '', LWIW_headerCtrlClick)
		Broker_LWIW.tt:AddSeparator(2)
		for i=1, #LWIW_SellList do
			LWIW_BR_TT_Line = Broker_LWIW.tt:AddLine(LWIW_SellList[i][1], HIGHLIGHT_FONT_COLOR_CODE..""..LWIW_SellList[i][2].."|r", HIGHLIGHT_FONT_COLOR_CODE..(GetCoinTextureString((LWIW_SellList[i][3]))).."|r")
			Broker_LWIW.tt:SetLineScript(LWIW_BR_TT_Line, "OnMouseDown", Broker_LWIW.OnClick, LWIW_SellList[i])
		end
		Broker_LWIW.tt:AddSeparator(2)
		if (LootWhatIWant.DeletedLost == nil) then
			LootWhatIWant.DeletedLost = 0
		end
		if (LootWhatIWant.VendorMade == nil) then
			LootWhatIWant.VendorMade = 0
		end
		Broker_LWIW.tt:AddLine(LWIW_TotalGoldText, '', HIGHLIGHT_FONT_COLOR_CODE..GetCoinTextureString(LWIW_GoldTotal).."|r")
		Broker_LWIW.tt:AddLine("")
		Broker_LWIW.tt:AddLine(LWIW_moneyLost, '', HIGHLIGHT_FONT_COLOR_CODE..GetCoinTextureString(LootWhatIWant.DeletedLost).."|r")

		Broker_LWIW.tt:AddLine(LWIW_moneyEarned, '', HIGHLIGHT_FONT_COLOR_CODE..GetCoinTextureString(LootWhatIWant.VendorMade).."|r")

		Broker_LWIW.tt:SmartAnchorTo(self)
		Broker_LWIW.tt:SetAutoHideDelay(0.25, self)

	  
		Broker_LWIW.tt:Show()
	end
end
		
------------------------------------------------------
--Create the LDB Object
------------------------------------------------------
Broker_LWIW.obj = ldb:NewDataObject("Broker_LWIW", {
	type = "data source",
	label = "Broker_LWIW",
	text = "0/0",
	icon = "Interface\\Icons\\INV_Misc_Bag_10",
	OnEnter = function(...) Broker_LWIW:Tooltip(...) end,
	OnClick = function(...) Broker_LWIW:OnClick(...) end,
	
})

------------------------------------------------------
--Handle of Clicking on LDB Plugin
------------------------------------------------------
function Broker_LWIW:OnClick(Local_SellList, button)	
	if (LootWhatIWant.toggleSellingStuff) then
	local LDBclick = false
	if not Local_SellList or not Local_SellList[1] or #Local_SellList < 1 then
		if (#LWIW_SellList > 0) then
			Local_SellList = LWIW_SellList[1]
		end
		LDBclick = true
	end
	if (LootWhatIWant.DeletedLost == nil) then
		LootWhatIWant.DeletedLost = 0
	end
	if (LDBclick) then
		if (button == "RightButton") then
			InterfaceOptionsFrame_OpenToCategory(LootWhatIWant_panel)
			return
		end
		
		if (button == "LeftButton" and IsShiftKeyDown()) then
			if (LWIW_SellList[1] ~= nil) then
				print(LWIW_DroppingVarString:format(LWIW_SellList[1][1], LWIW_SellList[1][2], GetCoinTextureString(LWIW_SellList[1][3])))
				PickupContainerItem(LWIW_SellList[1][6][1],LWIW_SellList[1][6][2])
				LootWhatIWant.DeletedLost = LootWhatIWant.DeletedLost + LWIW_SellList[1][3]
				DeleteCursorItem()
				return
			else
				print("LWIW: No items to drop.")
			end
		end
	else
		if Local_SellList and IsShiftKeyDown() then
			print(LWIW_DroppingVarString:format(Local_SellList[1], Local_SellList[2], GetCoinTextureString(Local_SellList[3])))
			LootWhatIWant.DeletedLost = LootWhatIWant.DeletedLost + Local_SellList[3]
			PickupContainerItem(Local_SellList[6][1],Local_SellList[6][2])
			DeleteCursorItem()
			return
		end
		if Local_SellList and IsControlKeyDown() then
			if (Local_SellList[4] == 0) then
				local currentItem = string.match(Local_SellList[1], "item:(%d+)")
				local itemName, iitemLink, iitemRarity, iitemLevel, iitemMinLevel, iitemType, iitemSubType, iitemStackCount, iitemEquipLoc, iitemTexture, iitemSellPrice = GetItemInfo(currentItem)
				LWIW_Keep(currentItem, itemName, iitemLink)
				Broker_LWIW:MainUpdate()
				return
			else
				local currentItem = string.match(Local_SellList[1], "item:(%d+)")
				if (LootWhatIWant.sellList[currentItem] ~= nil) then
					print(LWIW_ItemInSellListButClickedtoKeep:format(LootWhatIWant.sellList[currentItem]))
				else
					--print(LWIW_AddToKeepList:format(Local_SellList[1]))
					local currentItem = string.match(Local_SellList[1], "item:(%d+)")
					local itemName, iitemLink, iitemRarity, iitemLevel, iitemMinLevel, iitemType, iitemSubType, iitemStackCount, iitemEquipLoc, iitemTexture, iitemSellPrice = GetItemInfo(currentItem)
					LWIW_Keep(currentItem, itemName, iitemLink)
					Broker_LWIW:MainUpdate()
					return
				end
			end
		end
	end
	end
end

------------------------------------------------------
--Keep an item that's trash or autosold BoP Function
------------------------------------------------------
function LWIW_Keep(itemnum, name, ilink)
	if (LootWhatIWant.sellList[itemnum] ~= nil) then
		print("LWIW: "..ilink.." is already in your sell list, please remove first.")
	else
		if (LootWhatIWant.keepList[itemnum] ~= nil) then
			print(LWIW_AlreadyInKeepList(ilink))
		else
			print(LWIW_AddToKeepList:format(ilink))
			if (LootWhatIWant.keepList == nil) then
				
				LootWhatIWant.keepList = {}
			end
			LootWhatIWant.keepList[itemnum] = ilink
			if (LootWhatIWant.keepListcount == nil) then
				LootWhatIWant.keepListcount = {}
				LootWhatIWant.keepListcount[1] = itemnum
			else
				LootWhatIWant.keepListcount[(#LootWhatIWant.keepListcount + 1)] = itemnum
			end
			LWIW_KeepListSB_Update()
			Broker_LWIW:MainUpdate()
		end
	end
end


function LWIW_KeepCL(itemList)
	local atLeastOneValidItem = false
    
	local itemTable = LWIW_SplitStringIntoItems(itemList)
    
	for i,n in ipairs(itemTable) do
		itemnum = LWIW_GetItemNumber(n)
		if not (itemnum == nil) then
			LWIW_KeepAdding(itemnum, n)
			atLeastOneValidItem = true
		end
	end
    
	if(atLeastOneValidItem == false) then
		print(LWIW_NoValidLinkAfterCommand)
	end
	
end
------------------------------------------------------
--Add an item to auto sell list function -- break up the item list
------------------------------------------------------
function LWIW_Sell(itemList)
	local atLeastOneValidItem = false
    
	local itemTable = LWIW_SplitStringIntoItems(itemList)
    
	for i,n in ipairs(itemTable) do
		itemnum = LWIW_GetItemNumber(n)
		if not (itemnum == nil) then
			LWIW_SellAdding(itemnum, n)
			atLeastOneValidItem = true
		end
	end
    
	if(atLeastOneValidItem == false) then
		print(LWIW_NoValidLinkAfterCommand)
	end
	
end
function LWIW_KeepAdding(itemnum, name)
	if (LootWhatIWant.sellList[itemnum] ~= nil) then
		print("LWIW: "..name.." is already in your sell list, please remove first.")
	else
		if (LootWhatIWant.keepList[itemnum] ~= nil) then
			print(LWIW_AlreadyInKeepList:format(name))
		else
			print(LWIW_AddToKeepList:format(name))
			if (LootWhatIWant.keepList == nil) then
				
				LootWhatIWant.keepList = {}
			end
			LootWhatIWant.keepList[itemnum] = name
			if (LootWhatIWant.keepListcount == nil) then
				LootWhatIWant.keepListcount = {}
				LootWhatIWant.keepListcount[1] = itemnum
			else
				LootWhatIWant.keepListcount[(#LootWhatIWant.keepListcount + 1)] = itemnum
			end
			
			LWIW_KeepListSB_Update()
			Broker_LWIW:MainUpdate()
		end
	end
end

------------------------------------------------------
--Add an item to auto sell list function -- Individual
------------------------------------------------------
function LWIW_SellAdding(itemnum, name)
	if (LootWhatIWant.sellList[itemnum] ~= nil) then
		print(LWIW_AlreadyInSellList:format(name))
	else
		print(LWIW_AddToSellList:format(name))
		if (LootWhatIWant.sellList == nil) then
			
			LootWhatIWant.sellList = {}
		end
		LootWhatIWant.sellList[itemnum] = name
		if (LootWhatIWant.sellListcount == nil) then
			LootWhatIWant.sellListcount = {}
			LootWhatIWant.sellListcount[1] = itemnum
		else
			LootWhatIWant.sellListcount[(#LootWhatIWant.sellListcount + 1)] = itemnum
		end
		
		LWIW_SellListSB_Update()
		Broker_LWIW:MainUpdate()
	end
end

------------------------------------------------------
--This is the MainUpdate function, called on Bag Changes, keep list changes, sell list changes 
--It Updates the LDB ToolTip and the AutoSell list as items are received or the lists are changed.
------------------------------------------------------
function Broker_LWIW:MainUpdate()
	
	if (LootWhatIWant.toggleSellingStuff) then
		
		if not (LWIW_LootOpenedBool) then
			
			local GetNumSlotsReturnedZero = false
			for bag = 0, NUM_BAG_SLOTS do
				if C_Container.GetContainerNumSlots(bag) == 0 then
					GetNumSlotsReturnedZero = true
				end
			end
			local ttime = time()
			--print(NUM_BAG_SLOTS.." - "..ttime)
			--print(LWIW_TimeElapsedSinceLastBagUpdate)
			
			if (((ttime - LWIW_TimeElapsedSinceLastBagUpdate) > 0) or (GetNumSlotsReturnedZero)) then
				
				LWIW_TimeElapsedSinceLastBagUpdate = time()
				
				local total, free = 0, 0
				LWIW_AfterCombatUpdate = false
				LWIW_AfterBeingDeadUpdate = false
				local inLockdown = InCombatLockdown()
				--print("LWIW: Firing Main Update23")
				local isDeadOrGhost = UnitIsDeadOrGhost("Player")
				if (inLockdown) then
					LWIW_AfterCombatUpdate = true
					return
				end
				--print(inLockdown)
				if (isDeadOrGhost) then
					LWIW_AfterBeingDeadUpdate = true
					return
				end
				
				if (LootWhatIWant.keepList == nil) then
					LootWhatIWant.keepList = { }
				end
				--print(isDeadOrGhost)
				if (LootWhatIWant.sellList == nil) then
					LootWhatIWant.sellList = {}
				end
				LWIW_SellList = {}
				LWIW_SellListChecking = {}
				local tt = 1
				LWIW_GoldTotal = 0
				
				for bag = 0, NUM_BAG_SLOTS do
					 --print(bag)
					if bag >= 0 then
						local _, bagType = C_Container.GetContainerNumFreeSlots(bag)
						if bagType then
							
							total = total + C_Container.GetContainerNumSlots(bag)
							free = free + C_Container.GetContainerNumFreeSlots(bag)
						end
					end
					for slot=1, C_Container.GetContainerNumSlots(bag) do
						--print(slot)
						local info = C_Container.GetContainerItemInfo(bag, slot)
						local link = info and info.hyperlink;
						local count = info and info.stackCount;
						--print(link)
						if (link ~= nil) then
							--print("suck")
							local currentItem = string.match(link, "item:(%d+)")
							if (currentItem ~= nil) then
								local itemName, iitemLink, iitemRarity, iitemLevel, iitemMinLevel, iitemType, iitemSubType, iitemStackCount, iitemEquipLoc, iitemTexture, iitemSellPrice = GetItemInfo(link)
								
								--print(itemName)
								--print(ieffectiveILvl)
								--print(itemName)
								local currentStackValue = 0
								if (iitemSellPrice ~= nil) then
									currentStackValue = (iitemSellPrice * count)
								end
								if (currentStackValue ~= 0) then
									if (iitemRarity == 0) then
										if (not LootWhatIWant.keepList[currentItem]) then
											LWIW_GoldTotal = LWIW_GoldTotal + currentStackValue
											local lwselllist = {}
											lwselllist = {}
											lwselllist[1] = link
											lwselllist[2] = count
											lwselllist[3] = currentStackValue
											lwselllist[4] = iitemRarity
											lwselllist[5] = iitemTexture
											lwselllist[6] = { bag, slot }
											LWIW_SellListChecking[currentItem] = true
											if (#LWIW_SellList == 0) then
												LWIW_SellList[1] = {}
												LWIW_SellList[1] = lwselllist
											else
												local inserted = false
												for j =1, #LWIW_SellList do
													if (currentStackValue < LWIW_SellList[j][3]) then
														table.insert(LWIW_SellList, j, lwselllist)
														inserted = true
														break
													end
												end
												if (not inserted) then
													table.insert(LWIW_SellList, #LWIW_SellList+1, lwselllist)
												end
											end
											tt =tt+1
										end
									else
										if (LootWhatIWant.sellList[currentItem]) then
											LWIW_GoldTotal = LWIW_GoldTotal + currentStackValue
											local lwselllist = {}
											lwselllist = {}
											lwselllist[1] = link
											lwselllist[2] = count
											lwselllist[3] = currentStackValue
											lwselllist[4] = iitemRarity
											lwselllist[5] = iitemTexture
											lwselllist[6] = { bag, slot }
											LWIW_SellListChecking[currentItem] = true
											if (#LWIW_SellList == 0) then
												LWIW_SellList[1] = {}
												LWIW_SellList[1] = lwselllist
											else
												local inserted = false
												for j =1, #LWIW_SellList do
													if (currentStackValue < LWIW_SellList[j][3]) then
														table.insert(LWIW_SellList, j, lwselllist)
														inserted = true
														break
													end
												end
												if (not inserted) then
													table.insert(LWIW_SellList, #LWIW_SellList+1, lwselllist)
												end
											end
											tt =tt+1
										else
											
											if (not LootWhatIWant.keepList[currentItem]) then
												if iitemRarity < 5 then
													local addtolist = false
													if (IsEquippableItem(currentItem) and LootWhatIWant.SellBOPOveriLVL and iitemSellPrice > 0) then
														GameTooltip_SetDefaultAnchor(LootWhatIWantTooltip, UIParent)
														LootWhatIWantTooltip:SetHyperlink(iitemLink) 			
														--local main, off, oneh, twoh = false, false, false, false
														local bopt = false
														local ilvl = false
														local ilvl2
														local ieffectiveILvl, iisPreview, ibaseILvl = GetDetailedItemLevelInfo(link)
														ilvl2=ieffectiveILvl
														for i = 1, LootWhatIWantTooltip:NumLines() do 
															local text = _G["LootWhatIWantTooltipTextLeft"..i]:GetText()
															--print(text)
															if (text == LWIW_BoPText) then
																bopt = true
																break
															--else
																
																--local cclass = string.match(text, "Class: (%s)")
															--	local ilvl = string.find(text, LWIW_iLVLText)
															--	print(ilvl)
															--	if (ilvl ~= nil) then
																	
															--		ilvl2 = string.match(text, "%d+")
															--	print(ilvl2)
																	
															--	end
															end
															
															
														end
														--ilvl2 = tonumber(ilvl2)

															--print(bopt)
														LootWhatIWantTooltip:Hide()
														if (bopt) then
																											--	print(ilvl2)
														--	print(LootWhatIWant.KeepBOPMaxiLVL)
															if ilvl2~=nil then
															--print(ieffectiveILvl)
															--seprint(LootWhatIWant.KeepBOPMaxiLVL)
															if ieffectiveILvl < LootWhatIWant.KeepBOPMaxiLVL then
																LWIW_GoldTotal = LWIW_GoldTotal + currentStackValue
																local lwselllist = {}
																lwselllist = {}
																lwselllist[1] = link
																lwselllist[2] = count
																lwselllist[3] = currentStackValue
																lwselllist[4] = iitemRarity
																lwselllist[5] = iitemTexture
																lwselllist[6] = { bag, slot }
																LWIW_SellListChecking[currentItem] = true
																if (#LWIW_SellList == 0) then
																	LWIW_SellList[1] = {}
																	LWIW_SellList[1] = lwselllist
																else
																	local inserted = false
																	for j =1, #LWIW_SellList do
																		if (currentStackValue < LWIW_SellList[j][3]) then
																			table.insert(LWIW_SellList, j, lwselllist)
																			inserted = true
																			break
																		end
																	end
																	if (not inserted) then
																		table.insert(LWIW_SellList, #LWIW_SellList+1, lwselllist)
																	end
																end
																tt =tt+1
															end
															end
															--LWIW_ClassSpecifics[englishClass][armorcanbeused 
															--print(iitemSubType)
															
															
															--print(LWIW_ClassSpecifics[englishClass][iitemSubType])
															--print(LWIW_ClassSpecifics["ALL"][iitemEquipLoc])
															
														end	
													end
												end
											end
										end
									end
								end
							end
						end
					end
				end
				if (#LWIW_SellList > 0) then
					local s
					local taken = total - free
					local ibeg, _= string.find(LWIW_SellList[1][1], "%[")
					local _, iend = string.find(LWIW_SellList[1][1], "%]")
					if (ibeg ~= nil) and (iend ~= nil) then
						s = string.sub(LWIW_SellList[1][1], ibeg+1, (iend -1))
					end
					if (string.len(s) > 10) then
						s = string.sub(s, 1, 10)
						s = s.."..."
					end
					if (LWIW_SellList[1][4] == 0) then
						s = GRAY_FONT_COLOR_CODE..s.."|r"
					end
					self.obj.icon = LWIW_SellList[1][5]
					self.obj.text = s.." x"..LWIW_SellList[1][2].." "..GetCoinTextureString(LWIW_SellList[1][3]).." "..(string.format("|cff%s%d/%d|r",Crayon:GetThresholdHexColor(free / total), free, total))
					LWIW_sellAllButton:Enable()
				else
					self.obj.icon = "Interface\\Icons\\INV_Misc_Bag_10"
					self.obj.text = LWIW_NoItems..(string.format("|cff%s%d/%d|r", Crayon:GetThresholdHexColor(free / total), free, total))
				end
			end
		end
	end
end

------------------------------------------------------
--Get An Item Number form a link string
------------------------------------------------------
function LWIW_GetItemNumber(str)
    local itemnum
    if not str then
		return str
	end
    itemnum = string.match(str, "item:(%d+)")
    if not itemnum then
        local itemName, iitemLink, iitemRarity, iitemLevel, iitemMinLevel, iitemType, iitemSubType, iitemStackCount, iitemEquipLoc, iitemTexture, iitemSellPrice = GetItemInfo(str)
        if iitemLink then
	        itemnum = string.match(iitemLink, "item:(%d+)")
        end
    end
    
    return itemnum
end

-- ------------------------------------------------------------------
-- Prints debug info if flag is set.
-- ------------------------------------------------------------------
function LWIW_Debug(str)
    if(LWIW_debugFlag) then
        print("LWIW_DEBUG: "..str)
    end
end


-- ------------------------------------------------------------------
-- Adds a dungeon name to the "auto-loot" list.
-- ------------------------------------------------------------------
function LWIW_AddLootDungeon(dungeonName)

	if (LootWhatIWant.dungeonLootOK == nil) then
		LootWhatIWant.dungeonLootOK = {}
		LootWhatIWant.dungeonLootOK[1] = dungeonName
		LootWhatIWant.dungeonLootOK[2] = true
		print(LWIW_AutoConfirmBOPEnable:format(dungeonName))
		return
	end
	
	local index = #LootWhatIWant.dungeonLootOK
	
	for i=1, (index-1) do
		if(dungeonName == LootWhatIWant.dungeonLootOK[i]) then
			if(dungeonName == LootWhatIWant.dungeonLootOK[i]) then
				if(LootWhatIWant.dungeonLootOK[i+1] == false) then
					LootWhatIWant.dungeonLootOK[i+1] = true
					print(LWIW_AutoConfirmBOPEnable:format(dungeonName))
					return true
				else
					LootWhatIWant.dungeonLootOK[i+1] = true
					print(LWIW_AutoConfirmBOPAlready:format(dungeonName))
					return true
				end
			end
		end
	end
	
	LootWhatIWant.dungeonLootOK[index + 1] = dungeonName
	LootWhatIWant.dungeonLootOK[index + 2] = true
	print(LWIW_AutoConfirmBOPEnable:format(dungeonName))
    return true
end


-- ------------------------------------------------------------------
-- Removes a dungeon name from the "auto-loot" list.
-- ------------------------------------------------------------------
function LWIW_DelLootDungeon(dungeonName)
	if (LootWhatIWant.dungeonLootOK == nil) then
	   print(LWIW_AutoConfirmBOPDisable:format(dungeonName))
		return
	end
	
	local index = #LootWhatIWant.dungeonLootOK
	
	for i=1, (index - 1) do
		local testName = LootWhatIWant.dungeonLootOK[i]
		local testStatus = LootWhatIWant.dungeonLootOK[i+1]
		if (not testName) then
			-- 
		else
			if(testName == dungeonName) then
				if(testStatus) then
					LootWhatIWant.dungeonLootOK[i+1] = false
					print(LWIW_AutoConfirmBOPDisable:format(dungeonName))
					return true
				else
					LootWhatIWant.dungeonLootOK[i+1] = false
					print(LWIW_AutoConfirmBOPDisableAlready:format(dungeonName))
					return true
				end
			end
		end
	end
    print(LWIW_AutoConfirmBOPDisable:format(dungeonName))
    return true
end


-- ------------------------------------------------------------------
-- Check to see if a dungeon name is on the "auto-loot" list.
-- ------------------------------------------------------------------
function LWIW_MatchLootDungeon(dungeonName)
	if not LootWhatIWant.dungeonLootOK then
		return false
	end
	
	local index = #LootWhatIWant.dungeonLootOK
	
	if (index < 1) then
		return false
	end
	
	for i=1, index do
		local testName = LootWhatIWant.dungeonLootOK[i]
		local testStatus = LootWhatIWant.dungeonLootOK[i+1]
		if (not testName) then
			--
		else
			if(dungeonName == testName) then
				if(not testStatus) then
					return false
				end
				return true
			end
		end
	end
	
	return false
end

--- ------------------------------------------------------------------
-- Toggle a dungeon status in the "auto-loot" list.
-- ------------------------------------------------------------------
function LWIW_ToggleLootDungeon(dungeonName)
	local inInstance, instanceType = IsInInstance()
	if not inInstance then
		-- We're not in an instance.  Return failure.
		print(LWIW_NotInInstance)
		return false
    end
    
    if(LWIW_MatchLootDungeon(dungeonName) == true) then
        LWIW_DelLootDungeon(dungeonName)
    else
        LWIW_AddLootDungeon(dungeonName)
    end
    return true
end


-- ------------------------------------------------------------------
-- Check to see if we're ok to loot BoPs in a group situation.
-- ------------------------------------------------------------------
function LWIW_LootInstanceInGroup()
	if not ((GetNumGroupMembers() > 0) or (GetNumSubgroupMembers() > 0)) then
        -- We're not in a group.  We're clear to loot.
        return true
    end
	
	LWIW_ReportSettingsForZone(false)

	local inInstance, instanceType = IsInInstance()
	if not inInstance then
		-- We're not in an instance.  Use the global group setting.
		return LootWhatIWant.autolootWorldGroup
    end
    
    -- Check the instance name for the auto-confirm BoP status.
    if (LWIW_MatchLootDungeon(GetRealZoneText()) == true) then
        return true
    end

    -- We're not supposed to auto-confirm BoPs here.
    return false
end

-- ------------------------------------------------------------------
-- Handle all events sent by the game.
-- ------------------------------------------------------------------
function LootWhatIWant_EventHandler(self, event, ...)
  -- If we are disabled, quit here.
	if not (LootWhatIWant.enabled) then 
		return 
	end
	
	if not (LootWhatIWant.deleteGrays) then
		LootWhatIWant.deleteGrays = 0
	end
	
	-- look for the LOOT_OPENED event.
	--[[if (event == "WORLD_MAP_NAME_UPDATE") then
		
		if reportNextMapUpdate then
			reportNextMapUpdate = false
			LWIW_ReportSettingsForZone()
		end
		--Broker_LWIW:OnInitialize()	
		return]]
 	--else
	if (event == "BAG_UPDATE") then
		if (deleteAtNextBagUpdate) then
			--LWIW_ProcessDeletes()
		end
		
		Broker_LWIW:MainUpdate()
		
		return 
 	elseif (event == "LOOT_BIND_CONFIRM") then
 		if LWIW_CurrentLootSlot > 0 then
	 		LWIW_LootBoP()
	 	end
		return
	elseif (event == "ITEM_LOCK_CHANGED") then
		--print("here")
		LWIW_LockedChanged = false
		LWIW_BOA = false
		for i = 1, GameTooltip:NumLines() do 
			local text = _G["GameTooltipTextLeft"..i]:GetText()
			--print(text)
			if (text == ITEM_BNETACCOUNTBOUND) then
				LWIW_BOA = true
			end
		end
		--LootWhatIWantTooltip = GameTooltip
		LWIW_LockedChanged = true
		return
	elseif (event == "LOOT_OPENED") then
        -- Process the LOOT_OPENED event.
		--LWIW_LootOpenedBool = true
		if not LootWhatIWant.AutoLootBOA and LWIW_LockedChanged then
			
			if not LWIW_BOA then
				LWIW_LootOpened()
			else
				print("LWIW: Opening a Bind to Battle.net Account Bag, skip looting.")
			end
		else
			LWIW_LootOpened()
		end
		LWIW_LockedChanged = false
		LWIW_BOA = false
		return		
	elseif (event == "MERCHANT_SHOW") then
		Broker_LWIW:MainUpdate()
		if (LootWhatIWant.toggleSellingStuff) then
			if LootWhatIWant.AutoCleanUpAtVendor then
				StaticPopup_Show ("LWIW_DeleteBagItems")
			end
			if LootWhatIWant.AutoSellAtVendor then
				MerchantFrameLWIW_SellAllItems()
			end
		end
		return
	elseif (event == "PLAYER_LEAVE_COMBAT") then
		if (LWIW_AfterCombatUpdate) then
			Broker_LWIW:MainUpdate()
		end
	elseif (event == "PLAYER_ALIVE" or event == "PLAYER_UNGHOST") then
		if (LWIW_AfterBeingDeadUpdate) then
			Broker_LWIW:MainUpdate()
		end
	elseif (event == "MERCHANT_CLOSED") then
		LWIW_sellAllButton:Disable()
		LWIW_SellList = {}
		LWIW_SellListChecking = {}
		return
	elseif (event == "ADDON_LOADED") then
		if not LWIW_Loaded then
		--Broker_LWIW:OnInitialize()
			 LWIW_Loaded = true
			reportNextMapUpdate = true
			if (LootWhatIWant.lootRarity == nil) then
				LootWhatIWant.lootRarity = 2
			end
			--Set GUI check boxes
			if LootWhatIWant.KeepBOPMaxiLVL == nil then
				LootWhatIWant.KeepBOPMaxiLVL = 0
			end
			
			LWIW_DeleteOption:SetChecked(LootWhatIWant.deleteItems)
			LWIW_EnableDisableOption:SetChecked(LootWhatIWant.enabled)
			LWIW_CloseLootWindowOption:SetChecked(LootWhatIWant.closeLootWindow)
			UIDropDownMenu_SetSelectedID(LWIW_ThresholdDown_Menu, (LootWhatIWant.lootRarity - 1))
			LWIW_CBtoggleSellingStuff:SetChecked(LootWhatIWant.toggleSellingStuff)
			LWIW_MouseClicksOption:SetChecked(LootWhatIWant.MouseClicks)
			LWIW_SellSpamToggle:SetChecked(LootWhatIWant.SellSpamToggle)
			LWIW_AutoSellAtVendorToggle:SetChecked(LootWhatIWant.AutoSellAtVendor)
			LWIW_AutoCleanUpAtVendorToggle:SetChecked(LootWhatIWant.AutoCleanUpAtVendor)
			LWIW_GrayValueFrontString()
			LWIW_SellBOPiLVL4:SetText("|cff00ff00"..LootWhatIWant.KeepBOPMaxiLVL)
			LWIW_SellBoPToggle:SetChecked(LootWhatIWant.SellBOPOveriLVL)
			--Broker_LWIW:OnInitialize()
			Broker_LWIW:OnInitialize()
			  if (LootWhatIWant.toggleSellingStuff) then
				--print("LWIW: Broker plugin and other selling options enabled.")
				Broker_LWIW.obj.text = "0/0"
				Broker_LWIW.obj.icon = "Interface\\Icons\\INV_Misc_Bag_10"
				Broker_LWIW:MainUpdate()
				LWIW_sellAllButton:Show()
				LWIW_sellAllButton:Enable()
			    else
				--print("LWIW: Broker plugin and other selling options disabled.")
				Broker_LWIW.obj.text = ""
				Broker_LWIW.obj.icon = ""
				LWIW_sellAllButton:Hide()
				LWIW_sellAllButton:Disable()
			    end
			LWIW_InitializeConstants();
			return
		end
	end
end

function LWIW_InitializeConstants()
	
	--changed how weapon/armor API for classes.  Not going to bother updating
end


function LWIW_LootBoP()
	local slotToLoot = LWIW_CurrentLootSlot
	LWIW_CurrentLootSlot = 0
	
    -- Check to see if we've enabled auto-confirming BoPs in this area.
    
    if LWIW_LootInstanceInGroup() then
		LootSlot(slotToLoot)
		StaticPopup_Hide("LOOT_BIND")
		ConfirmLootSlot(slotToLoot)
	else
		LWIW_SkippedBOP = slotToLoot
    end
end

-- ------------------------------------------------------------------
-- Report the user's settings for the current zone.
-- ------------------------------------------------------------------
function LWIW_ReportSettingsForZone(showWorld)
	if not reportNextMapUpdate then
		reportNextMapUpdate = false
		return
	end
	
	reportNextMapUpdate = false
	
	if not ((GetNumRaidMembers() > 0) or (GetNumPartyMembers() > 0)) then
		if not showWorld then
			return
		end
	end
	
	local inInstance, instanceType = IsInInstance()
	if not inInstance then
		if showWorld then
			-- We're not in an instance.  Use the global group setting.
			if(LootWhatIWant.autolootWorldGroup) then
				print(LWIW_WorldAutoConfirmEnable)
			else
				print(LWIW_WorldAutoConfirmEnable)
			end
			return
		end
    end
       local zone = GetRealZoneText()
    if (LWIW_MatchLootDungeon(zone) == true) then
		print(LWIW_ZoneAutoConfirmEnable:format(zone))
    else
		print(LWIW_ZoneAutoConfirmDisable:format(zone))
    end
end


-- ------------------------------------------------------------------
-- Handle the LOOT_OPENED event.  This checks for looting options and
-- grabs everything in the loot object (if it's ok).
-- ------------------------------------------------------------------
function LWIW_LootOpened()
    -- Check to see if the built=in autoloot is turned on.  If it is, we can't
    -- do our work, and tell the user this.
    local auloot = GetCVar("autoLootDefault")
    if (auloot == "1") then
        print(LWIW_AutoLootSettingOn)
        return
    end
    
	-- Make sure we have something to loot
	if (GetNumLootItems() > 0) then
		LWIW_SkippedBOP = 0
		-- Process through the loot object contents
		for i = 1, GetNumLootItems() do
			LWIW_CurrentLootSlot = i
			local x = LWIW_LootThisItem(i)
			--print(x)
			if (x == true) then
				deleteAtNextBagUpdate = true
			end
			
		end
        
		if (LootWhatIWant.closeLootWindow) then
			local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()				
			if (not LWIW_NoBagSpaceLeft()) then
				if (LWIW_SkippedBOP ~= 0) then
					if ((lootmethod == "master") and (masterlooterPartyID == 0) and (LWIW_Rarity >= GetLootThreshold())) then
						print("LWIW: Masterlooter is set, and you are the ML.  Keeping Loot Window Open.")
					elseif (( LWIW_Rarity >= LootWhatIWant.lootRarity))then
						print("LWIW: Item is not below your threshold of: "..LWIW_Options_ThresholdlDropDown_Menu_List[(LootWhatIWant.lootRarity-1)].name..", keeping loot window open.")
					else
						if (not  InCombatLockdown()) then
							CloseLoot()
						end
					end
				end
			else
				print("LWIW: Bags are full, keeping Loot Window open.")				
			end
		end
		
		if (LWIW_SkippedBOP > 0) then
			LootSlot(LWIW_SkippedBOP)
		end
	else
		-- We have nothing to loot.  Close the loot window.
		if (not  InCombatLockdown()) then
			CloseLoot()
		end
	end
	LWIW_Rarity = 0
	LWIW_LootOpenedBool = false
end

-- ------------------------------------------------
-- Check to see if any bag space is free
-- ------------------------------------------------
function LWIW_NoBagSpaceLeft()
	local unusedbagspace = 0
	for bag = 0, NUM_BAG_SLOTS do
		local numberOfFreeSlots, BagType = C_Container.GetContainerNumFreeSlots(bag);
		if ((BagType ~= 1) and (BagType ~= 2) and (BagType ~=4)) then
			-- Don't care about ammo/quiver/soul bags since 99.9% of loot can't go in them anyways
			unusedbagspace = unusedbagspace + numberOfFreeSlots
		end
	end
	if (unusedbagspace == 0) then
		return true
	else
		return false
	end
end

-- ---------------------------------------------------------------------------------
-- Copy toons Blacklist to global list so it can be accessed by other toons
-- ---------------------------------------------------------------------------------
function LWIW_TransferLocalBLtoGlobalBL()
	if (LootWhatIWant.blacklistcount == nil) then
		print("You have no items in your blacklist.  No need to copy globally.")
		return
	end
	if ((LootWhatIWant_GlobalBlackList == nil) or (#LootWhatIWant_GlobalBlackList == 0)) then
		LootWhatIWant_GlobalBlackList = {}
		local playerName = UnitName("player");
		LootWhatIWant_GlobalBlackList[1] = {}
		LootWhatIWant_GlobalBlackList[1].blacklist = { }
		LootWhatIWant_GlobalBlackList[1].blacklistcount = { }
		LootWhatIWant_GlobalBlackList[1].playername = playerName
		LootWhatIWant_GlobalBlackList[1].blacklist = LootWhatIWant.blacklist
		LootWhatIWant_GlobalBlackList[1].blacklistcount = LootWhatIWant.blacklistcount
		for i = 1, #LootWhatIWant_GlobalBlackList do
			info            = {};
			info.text       = LootWhatIWant_GlobalBlackList[i].playername;
			info.func     = LWIW_ProfileDownMenu_OnClick;
			UIDropDownMenu_AddButton(info);
		end
	else
		local found = false
		local placeholder = -1
		local playerName = UnitName("player");
		for i = 1, #LootWhatIWant_GlobalBlackList do
			if LootWhatIWant_GlobalBlackList[i].playername ==  playerName then
				found = true
				placeholder = i
			end
		end
		if found then
			LootWhatIWant_GlobalBlackList[placeholder].blacklist = LootWhatIWant.blacklist
			LootWhatIWant_GlobalBlackList[placeholder].blacklistcount = LootWhatIWant.blacklistcount
		else
			
			placeholder = #LootWhatIWant_GlobalBlackList+1
			LootWhatIWant_GlobalBlackList[placeholder] = {}
			LootWhatIWant_GlobalBlackList[placeholder].blacklist = { }
			LootWhatIWant_GlobalBlackList[placeholder].blacklistcount = { }
			LootWhatIWant_GlobalBlackList[placeholder].playername = playerName
			LootWhatIWant_GlobalBlackList[placeholder].blacklist = LootWhatIWant.blacklist
			LootWhatIWant_GlobalBlackList[placeholder].blacklistcount = LootWhatIWant.blacklistcount
			for i = 1, #LootWhatIWant_GlobalBlackList do
				info            = {};
				info.text       = LootWhatIWant_GlobalBlackList[i].playername;
				info.func     = LWIW_ProfileDownMenu_OnClick;
				UIDropDownMenu_AddButton(info);
			end
		end
	end
	LWIW_ProfileDownMenu_OnLoad()
end

-------------------------------------------------------
--GUI Functions -- Following handle DropDown menus'
-------------------------------------------------------
function LWIW_ProfileDownMenu_OnClick(self)
	local gid = self:GetID()
	UIDropDownMenu_SetSelectedName(LWIW_ProfileDown_Menu, LootWhatIWant_GlobalBlackList[gid].playername)
	LWIW_ProfileBlackListSB_Update()
end

function LWIW_Options_ThresholdDropDown_Menu_OnClick(self)
	local gid = self:GetID()
	LootWhatIWant.lootRarity = gid + 1
	UIDropDownMenu_SetSelectedID(LWIW_ThresholdDown_Menu, (LootWhatIWant.lootRarity - 1))
end

-------------------------------------------------------
--Transfer a list that has been uploaded to global to current toon
-------------------------------------------------------
function LWIW_TransferGlobalBLtoLocalBL(otherToonName)
	local found
	local placeholder
	for i = 1, #LootWhatIWant_GlobalBlackList do
		if LootWhatIWant_GlobalBlackList[i].playername ==  otherToonName then
			found = true
			placeholder = i
		end
	end
	if (found) then
		LootWhatIWant.blacklist = LootWhatIWant_GlobalBlackList[placeholder].blacklist
		LootWhatIWant.blacklistcount = LootWhatIWant_GlobalBlackList[placeholder].blacklistcount
	end
end
-- -----------
-------------------------------------------------------
-- Loot one item, and return if it matches the delete settings.
-- ------------------------------------------------------------------
function LWIW_LootThisItem(slotNumber)
    local returnValue = false

    local lootIcon, lootName, lootQuantity, currencyID, rarity, locked = GetLootSlotInfo(slotNumber)
	--local lootIcon, lootName, lootQuantity, currencyID, lootQuality, locked, isQuestItem, questID, isActive
	--print(rarity)
    if (rarity ~= nil) then
	    if (rarity >  LWIW_Rarity) then
		LWIW_Rarity = rarity
	    end
    end
    local lootLink = GetLootSlotLink(slotNumber)
  --[[  if (locked == 1) then
        -- This is a locked item.  We can't do anything, so bail.
	print("here1")
        return false
    end]]
    
    if not (lootQuantity ~= 0) then
        -- This is a coin listing.  Grab it and bail.
        LootSlot(slotNumber)
        return false
    end
    
    if (rarity == 0) then
		--print('here')
        -- We have a gray item.  Check for deleting this.
        if not (LootWhatIWant.deleteGrays == 0) then
		--print('here3')
            returnValue = true
        end
    end
    
    local itemNum = LWIW_GetItemNumber(lootLink)
      --print(itemNum)
    if itemNum then
		--	print(LootWhatIWant.blacklist[itemNum])
		--	print(itemNum)
    		if(LootWhatIWant.blacklist[itemNum]) then
			-- The item is blacklisted.
			returnValue = true
		end
    end

    if ((returnValue == true) and (LootWhatIWant.deleteItems == false)) then
        -- If we're not going to loot the item because we dont want it and we
        -- won't be deleting it, then we dont want to have the calling function
        -- execute the deletion afterwards.  Then inform the user of the skip.
        returnValue = false
        print("LWIW: Skipping loot of "..lootLink)
    else
        -- We want this item. Take it.
	LootSlot(slotNumber)
	-- Hide any BoP warnings.  We'll get another shortly is we're staying open.
	StaticPopup_Hide("LOOT_BIND")
    end
    return returnValue
end


-- ------------------------------------------------------------------
-- Delete one item from your bags, and display what was done.
-- ------------------------------------------------------------------
function LWIW_DeleteItem(bag, slot)
    if (LootWhatIWant.deleteItems == false) then
        -- We were called, but deleting items is set to OFF. Bail.
        return
    end
    
   local info = C_Container.GetContainerItemInfo(bag, slot)
	local link = info and info.hyperlink;
       --print(itemID)
	    --local b = CreateFrame("Button", "DeleteCursorItemButton")
		--b:SetScript("OnClick", function()
			--DeleteCursorItem()
		--end)
    PickupContainerItem(bag, slot)
   DeleteCursorItem()
		--StaticPopup_Show("LWIW_DeleteBagItem")
    print("LWIW: Deleted: "..link)
end


-- ------------------------------------------------------------------
-- Check your bags for items that match the deletion settings, and clear them out.
-- ------------------------------------------------------------------
function LWIW_ProcessDeletes()
	deleteAtNextBagUpdate = false
	if (LootWhatIWant.deleteItems == false) then
        -- We were called, but deleting items is set to OFF. Bail.
		return
	end
	local total, free = 0, 0
	local goldtotal, tt = 0, 1
	for bag = 0, NUM_BAG_SLOTS do
		if bag >= 0 then
			local bagType = C_Container.GetContainerNumFreeSlots(bag)
			if bagType then
				total = total + C_Container.GetContainerNumSlots(bag)
				free = free + C_Container.GetContainerNumFreeSlots(bag)
			end
		end
		for slot=1, C_Container.GetContainerNumSlots(bag) do
			local info = C_Container.GetContainerItemInfo(bag, slot)
			local link = info and info.hyperlink;
			if (link ~= nil) then
				local currentItem = string.match(link, "item:(%d+)")
				--print(currentItem)
				if (currentItem ~= nil) then
					local itemName, iitemLink, iitemRarity, iitemLevel, iitemMinLevel, iitemType, iitemSubType, iitemStackCount, iitemEquipLoc, iitemTexture, iitemSellPrice = GetItemInfo(currentItem)
					
					-- Is the item in the blacklist?
					if (LootWhatIWant.blacklist[currentItem]) then
						 PickupContainerItem(bag, slot)
						 
						DeleteCursorItem()
						 print("LWIW: Deleted: "..iitemLink)
						 print("LWIW: Deleted: "..iiTemLink)
						 
					else
						if (iitemRarity == 0) then
							-- We have a gray item.  Now what?
							-- Are we to delete *ALL* gray items?
							if (LootWhatIWant.deleteGrays == -1) then
								LWIW_DeleteItem(bag,slot)
								
							end
							local currentStackValue
							-- Get the current stack value for the item
							if (iitemSellPrice ~= nil) then
								currentStackValue = (iitemSellPrice * iitemStackCount)
							else
								currentStackValue = 0
							end
							-- Is the value of the gray stack below the value threshold?
							if (currentStackValue < LootWhatIWant.deleteGrays) then
								LWIW_DeleteItem(bag,slot)
								
							end	
						end
					end
				end
			end
		end
	end
	local taken = total - free
end


-- ------------------------------------------------------------------
-- Add an item to the blacklist.
-- ------------------------------------------------------------------
function LWIW_Add(itemnum, name)
	if (LootWhatIWant.blacklist[itemnum] ~= nil) then
		LWIW_Remove(itemnum, name)
	else
		print("LWIW: "..name.." has been added to your blacklist.")
		LootWhatIWant.blacklist[itemnum] = name
		if (LootWhatIWant.blacklistcount == nil) then
			LootWhatIWant.blacklistcount = {}
			LootWhatIWant.blacklistcount[1] = itemnum
		else
			LootWhatIWant.blacklistcount[(#LootWhatIWant.blacklistcount + 1)] = itemnum
		end
		LWIW_BlackListSB_Update()
	end
end

-------------------------------------------------------------------------------------
-- Changes the gray value of the text field in the gui
-------------------------------------------------------------------------------------
function LWIW_GrayValueFrontString()
	if ((LootWhatIWant.deleteGrays == -1) or (LootWhatIWant.deleteGrays == 0)) then
		LWIW_DeleteGrays4:SetText(LootWhatIWant.deleteGrays)
	else
		LWIW_DeleteGrays4:SetText(GetCoinTextureString(LootWhatIWant.deleteGrays))
	end
end
-- ------------------------------------------------------------------
-- Remove an item from the blacklist.
-- ------------------------------------------------------------------
function LWIW_Remove(itemnum, name)
	if (LootWhatIWant.blacklist[itemnum] ==  nil) then
		print("LWIW: "..name.." is not in your blacklist.")
	else
		print("LWIW: "..name.." has been removed from your blacklist.")
		LootWhatIWant.blacklist[itemnum] = nil
		for i = 1, #LootWhatIWant.blacklistcount do
			if (LootWhatIWant.blacklistcount[i] == itemnum) then
				table.remove(LootWhatIWant.blacklistcount, i)
				break
			end
		end
		LWIW_BlackListSB_Update()
	end
end

------------------------------------------------------------------
--Remove an item from your Keep List, called from GUI only.
------------------------------------------------------------------
function LWIW_KeepItem_Removal(itemnum, name)
	if (LootWhatIWant.keepList[itemnum] ==  nil) then
		print("LWIW: "..name.." is not in your keeplist.")
	else
		print("LWIW: "..name.." has been removed from your keeplist.")
		LootWhatIWant.keepList[itemnum] = nil
		for i = 1, #LootWhatIWant.keepListcount do
			if (LootWhatIWant.keepListcount[i] == itemnum) then
				table.remove(LootWhatIWant.keepListcount, i)
				break
			end
		end
		LWIW_KeepListSB_Update()
		Broker_LWIW:MainUpdate()

	end
end

------------------------------------------------------------------
--Remove an item from your sell list, called from GUI only.
------------------------------------------------------------------
function LWIW_SellItem_Removal(itemnum, name)
	if (LootWhatIWant.sellList[itemnum] ==  nil) then
		print("LWIW: "..name.." is not in your selllist.")
	else
		print("LWIW: "..name.." has been removed from your selllist.")
		LootWhatIWant.sellList[itemnum] = nil
		for i = 1, #LootWhatIWant.sellListcount do
			if (LootWhatIWant.sellListcount[i] == itemnum) then
				table.remove(LootWhatIWant.sellListcount, i)
				break
			end
		end
		LWIW_SellListSB_Update()
		Broker_LWIW:MainUpdate()

	end
end

-- ------------------------------------------------------------------
-- Toggle ALL gray item deletion.
-- ------------------------------------------------------------------
function LWIW_ToggleGrayDeletes()
    if (LootWhatIWant.deleteGrays == 0) then
        LootWhatIWant.deleteGrays = -1
	print("LWIW: Gray items WILL BE DELETED when looted.")
    elseif (LootWhatIWant.deleteGrays == -1) then
        LootWhatIWant.deleteGrays = 0
        print("LWIW: Gray items will NOT be deleted when looted.")
    end
    LWIW_GrayValueFrontString()
end

-- ------------------------------------------------------------------
-- Toggle Selling Spam
-- ------------------------------------------------------------------
function LWIW_ToggleSellSpam()
	if (LootWhatIWant.toggleSellingStuff) then
		if LootWhatIWant.SellSpamToggle then
			LootWhatIWant.SellSpamToggle = false
			print("LWIW: Will list each item sold at vendor by LWIW.")
		else
			LootWhatIWant.SellSpamToggle = true
			print("LWIW: Will NOT list each item sold at vendor by LWIW.")
		end
	else
		print("LWIW: Must enable selling options first")
	end
	LWIW_SellSpamToggle:SetChecked(LootWhatIWant.SellSpamToggle)
end

function LWIW_ToggleSellBoP()
	if (LootWhatIWant.toggleSellingStuff) then
		if LootWhatIWant.SellBOPOveriLVL then
			LootWhatIWant.SellBOPOveriLVL = false
			print("LWIW: Will NOT sell any BoP items.")
		else
			LootWhatIWant.SellBOPOveriLVL = true
			print("LWIW: Will sell all BoP items below set ilvl.")
		end
	else
		print("LWIW: Must enable selling options first")
	end
	LWIW_SellBoPToggle:SetChecked(LootWhatIWant.SellBOPOveriLVL)
end
-- ------------------------------------------------------------------
-- Toggle Auto Selling when visiting Vendor
-- ------------------------------------------------------------------
function LWIW_AutoSellAtVendorToggleFunction()
	if (LootWhatIWant.toggleSellingStuff) then
		if LootWhatIWant.AutoSellAtVendor then
			LootWhatIWant.AutoSellAtVendor = false
			print("LWIW: Will NOT auto sell items in sell list when visiting vendor.  Must click button.")
		else
			LootWhatIWant.AutoSellAtVendor = true
			print("LWIW: Will auto sell items in sell list when visiting vendor.")
		end
	else
		print("LWIW: Must enable selling options first")
	end
	LWIW_AutoSellAtVendorToggle:SetChecked(LootWhatIWant.AutoSellAtVendor)
end

-- ------------------------------------------------------------------
-- Toggle Auto CleanUp Blacklist items when visiting Vendor
-- ------------------------------------------------------------------
function LWIW_AutoCleanUpAtVendorToggleFunction()
	if (LootWhatIWant.toggleSellingStuff) then
		if LootWhatIWant.AutoCleanUpAtVendor then
			LootWhatIWant.AutoCleanUpAtVendor = false
			print("LWIW: Will NOT auto clean bags of blacklist items at vendor")
		else
			LootWhatIWant.AutoCleanUpAtVendor = true
			print("LWIW: Will auto clean bags of blacklist items at vendor")
		end
	else
		print("LWIW: Must enable selling options first")
	end
	LWIW_AutoCleanUpAtVendorToggle:SetChecked(LootWhatIWant.AutoCleanUpAtVendor)
end

-- ------------------------------------------------------------------
-- Display help for the deletegray setting.
-- ------------------------------------------------------------------
function LWIW_SetDeleteGraysPrintUsage()
    print("    gray [value] -- If [value] is 0, all grays will be looted and kept.")
    print("        If [value] is -1, all grays will be deleted from your bags next time you loot.")
    print("        Otherwise, all gray stacks with a sale amount below [value] will be deleted from your bags next time you loot.")
end

function LWIW_SetiLVLPrintUsage()
    print("       All BoP that are less then the ilvl you put in will be sold.")
end

-- ------------------------------------------------------------------
-- Set deletegray options
-- ------------------------------------------------------------------
function LWIW_SetDeleteGrays(itemValue)
    if (itemValue == "") then
        LWIW_SetDeleteGraysPrintUsage()
        return
    end

    local newValue = tonumber(itemValue)
    
    if (newValue == nil) then
        LWIW_SetDeleteGraysPrintUsage()
        return
    end

    if (newValue < 0) then
        LootWhatIWant.deleteGrays = -1
        print("LWIW: All gray items WILL BE DELETED when looted.")
	LWIW_GrayValueFrontString()
        return
    end
    
    if (newValue == 0) then
        LootWhatIWant.deleteGrays = 0
        print("LWIW: Gray items will NOT be deleted when looted.")
	LWIW_GrayValueFrontString()
        return
    end
    
    LootWhatIWant.deleteGrays = newValue
    LWIW_GrayValueFrontString()
    print("LWIW: Deleting gray item stacks under a value of "..GetCoinTextureString(LootWhatIWant.deleteGrays))
end

function LWIW_SetiLVLSell(itemValue)
	if (itemValue == "") then
		LWIW_SetiLVLPrintUsage()
		return
	end

	local newValue = tonumber(itemValue)
	if newValue<0 then
		print("Invalid number")
		LWIW_iLVLValueFontString()
		return
	else
		LootWhatIWant.KeepBOPMaxiLVL=newValue
		print("LWIW: all BoP items below ilvl of "..LootWhatIWant.KeepBOPMaxiLVL.." will be sold.")
		LWIW_iLVLValueFontString()
		return
	end
end

function LWIW_iLVLValueFontString()

	LWIW_SellBOPiLVL4:SetText("|cff00ff00"..LootWhatIWant.KeepBOPMaxiLVL)

end	
-- ------------------------------------------------------------------
-- String function trim() - clears whitespace at front and end of a string
-- ------------------------------------------------------------------
function trim (s)
    return (string.gsub(s, "^%s*(.-)%s*$", "%1"))
end


-- ------------------------------------------------------------------
-- Adds multiple items to the blacklist
-- ------------------------------------------------------------------
function LWIW_AddToBlacklist(itemList)
    local atLeastOneValidItem = false
    
    local itemTable = LWIW_SplitStringIntoItems(itemList)
    
    for i,n in ipairs(itemTable) do
        itemnum = LWIW_GetItemNumber(n)
        if not (itemnum == nil) then
            LWIW_Add(itemnum, n)
            atLeastOneValidItem = true
        end
    end
    
    if(atLeastOneValidItem == false) then
        print("LWIW: No valid item link after the ADD command.")
    end
end


-- ------------------------------------------------------------------
-- Removes multiple items from the blacklist
-- ------------------------------------------------------------------
function LWIW_RemoveFromBlacklist(itemList)
    local atLeastOneValidItem = false
    
    local itemTable = LWIW_SplitStringIntoItems(itemList)
    
    for i,n in ipairs(itemTable) do
        itemnum = LWIW_GetItemNumber(n)
        if not (itemnum == nil) then
            LWIW_Remove(itemnum, n)
            atLeastOneValidItem = true
        end
    end
    
    if(atLeastOneValidItem == false) then
        print("LWIW: No valid item link after the REMOVE command.")
    end
end

-- ------------------------------------------------------------------
-- Removes multiple items from the Selllist
-- ------------------------------------------------------------------
function LWIW_RemoveFromSellList(itemList)
    local atLeastOneValidItem = false
    
    local itemTable = LWIW_SplitStringIntoItems(itemList)
    
    for i,n in ipairs(itemTable) do
        itemnum = LWIW_GetItemNumber(n)
        if not (itemnum == nil) then
            LWIW_SellItem_Removal(itemnum, n)
            atLeastOneValidItem = true
        end
    end
    
    if(atLeastOneValidItem == false) then
        print("LWIW: No valid item link after the REMOVE command.")
    end
end

-- ------------------------------------------------------------------
-- Splits a string into a table of values based on "[]" delimiters.
-- ------------------------------------------------------------------
function LWIW_SplitStringIntoItems(inString)
    LWIW_Debug(inString)
    
    local itemTable = {}
    local itemStart = 1
    local itemEnd = 1
    repeat
        itemStart = string.find(inString, '%|c', itemEnd)
        if not itemStart then
            return itemTable
        end
        
        itemEnd = string.find(inString, '%|r', itemStart+1)
        if not itemEnd then
            return itemTable
        end
        
        local f = string.sub(inString, itemStart, itemEnd+1)
        table.insert(itemTable, f)
    until itemStart > string.len(inString)
    
    return itemTable
end


-- ------------------------------------------------------------------
-- Toggle item deletion on or off
-- ------------------------------------------------------------------
function LWIW_ToggleDeletes(cmd)
    if (trim(cmd) == "") then
        LootWhatIWant.deleteItems = not (LootWhatIWant.deleteItems)
    else
        LootWhatIWant.deleteItems = parse_truefalse(cmd)
    end
    
    if (LootWhatIWant.deleteItems) then
        print("LWIW: Will loot and delete specified items from the corpse.")
    else
        print("LWIW: Will NOT loot items but leave them on the corpse.")
    end
    LWIW_DeleteOption:SetChecked(LootWhatIWant.deleteItems)
end

---------------------------------------
-- Toggle Enable/Disable
--------------------------------------
function LWIW_ToggleEnable(cmd)
	if (trim(cmd) == "") then
		LootWhatIWant.enabled = not (LootWhatIWant.enabled)
	elseif (trim(cmd) == "disable") then
		LootWhatIWant.enabled = false
	elseif (trim(cmd) == "enable") then
		LootWhatIWant.enabled = true
	end
	 if (LootWhatIWant.enabled) then
		print("LWIW: Addon enabled")
	else
		print("LWIW: Addon disabled")
        end
	LWIW_EnableDisableOption:SetChecked(LootWhatIWant.enabled)
end
        
-- ------------------------------------------------------------------
-- Toggle auto-window closure on or off
-- ------------------------------------------------------------------
function LWIW_ToggleCloseWindow(cmd)
    if (trim(cmd) == "") then
        LootWhatIWant.closeLootWindow = not (LootWhatIWant.closeLootWindow)
    else
        LootWhatIWant.closeLootWindow = parse_truefalse(cmd)
    end
    
    if (LootWhatIWant.closeLootWindow) then
        print("LWIW: Will auto-close loot window even when some items are not looted.")
    else
        print("LWIW: Will leave loot window open if some items are not looted.")
    end
    LWIW_CloseLootWindowOption:SetChecked(LootWhatIWant.closeLootWindow)
end

function LWIW_ToggleMouseClicks(cmd)
	if (LootWhatIWant.MouseClicks) then
		LootWhatIWant.MouseClicks = false
		print("LWIW: Will NOT allow mouse clicks to add items to sell/black lists.")
	else
		LootWhatIWant.MouseClicks = true
		print("LWIW: Will now allow mouse clicks to add items to sell/black lists.")
	end
	LWIW_MouseClicksOption:SetChecked(LootWhatIWant.MouseClicks)
end


------------------------------------------------------------------
--Toggles selling options enabled or disabled.
------------------------------------------------------------------
function LWIW_ToggleSellingOptions(cmd)
    if (trim(cmd) == "") then
        LootWhatIWant.toggleSellingStuff= not (LootWhatIWant.toggleSellingStuff)
    else
        LootWhatIWant.toggleSellingStuff = parse_truefalse(cmd)
    end
    
    if (LootWhatIWant.toggleSellingStuff) then
        print(LWIW_LDBPluginEnable)
	Broker_LWIW.obj.text = "0/0"
	Broker_LWIW.obj.icon = "Interface\\Icons\\INV_Misc_Bag_10"
	Broker_LWIW:MainUpdate()
	--Broker_LWIW:OnInitialize()	
	
	
	LWIW_sellAllButton:Enable()
	LWIW_sellAllButton:Show()
    else
        print(LWIW_LDBPluginDisable)
	Broker_LWIW.obj.text = ""
	Broker_LWIW.obj.icon = ""
	LWIW_sellAllButton:Disable()
	
	LWIW_sellAllButton:Hide()
	LootWhatIWant.AutoSellAtVendor = false
	LootWhatIWant.SellSpamToggle = false
	
	
    end
    LWIW_CBtoggleSellingStuff:SetChecked(LootWhatIWant.toggleSellingStuff)
    LWIW_SellSpamToggle:SetChecked(LootWhatIWant.SellSpamToggle)
    LWIW_AutoSellAtVendorToggle:SetChecked(LootWhatIWant.AutoSellAtVendor)		
end	
	
-- ------------------------------------------------------------------
-- Toggle auto-loot for world groups on or off
-- ------------------------------------------------------------------
function LWIW_ToggleWorldGroupLoot(cmd)
    if (trim(cmd) == "") then
        LootWhatIWant.autolootWorldGroup = not (LootWhatIWant.autolootWorldGroup)
    else
        LootWhatIWant.autolootWorldGroup = parse_truefalse(cmd)
    end
    
    if (LootWhatIWant.autolootWorldGroup) then
        print(LWIW_WorldAutoLootEnable)
    else
        print(LWIW_WorldAutoLootDisable)
    end
end


-- ------------------------------------------------------------------
-- Parse a string for a true/false and return the boolean equivalent
-- ------------------------------------------------------------------
function parse_truefalse(str)
	local s = string.lower(trim(str))
	
    if (s == "true") or (s == "on") or (s == "yes") then
        return true
    end
    
    local x = tonumber(s)
    if not x then
        return false
    end
    
    if (x == 0) then
        return false
    end
    
    return true
end


-- ------------------------------------------------------------------
-- Print command usage in chat
-- ------------------------------------------------------------------
function LWIW_PrintUsage()
    print("LootWhatIWant Usage")
    print("Usage:  "..commandPrefix.." [command] [options]")
    print("Commands:")
    print("    help -- Prints this help message")
    print("    enable -- enable this addon")
    print("    disable -- disable this addon")
    print("    gui -- Display Blacklist Interface")
    print("    add [item] -- add an item to the blacklist.  Must be an item link (shift-click the item after typing ADD).")
    print("    keep [item} -- add an item to your keep list (this works if BoP sell of low ilvl is on but you want something marked cosmetic)")
    print("    remove [item] -- remove an item from the blacklist.  Must be an item link (shift-click the item after typing REMOVE).")
    print("    world -- Enable/disable auto looting in the main world while in a group.  Enabled by default.")
    print("    instance -- Enable/disable auto looting in the current instance while in a group.  Disabled by default.")
    print("    [zg | mc | kz | aq20 | aq40] -- Enable/disable auto looting in ZG/MC/KZ/AQ20/AQ40 respectivily.  Disabled by default.")
    print("    delete -- toogles looting then deleting items in your blacklist.  Disabled by default.  Have tested as much as I can, Use this at YOUR own risk.")
    print("    sellingoptions  -- toggles selling/trash options within this mod.")
    print("    sell [item] -- add a non grey item to your auto sell list.")
    print("    remsell [item] -- remove a non grey item from your auto sell list.")
    print("    autoclose -- Toggles auto-closing loot window even when some items are not looted.")
    LWIW_SetDeleteGraysPrintUsage()
end

-- ------------------------------------------------------------------
-- Process chat commands
-- ------------------------------------------------------------------
function LWIW_ProcessChatCommand(cmd, rmd, line)
    cmd = string.lower(cmd)

    if (cmd == "gray") then
        LWIW_SetDeleteGrays(rmd)
		return
	end

    if (cmd == "add") then
        LWIW_AddToBlacklist(rmd)
        return
    end
    if (cmd == "sell") then
	LWIW_Sell(rmd)
	return
    end
    if (cmd == "remove") then
        LWIW_RemoveFromBlacklist(rmd)
        return
    end
    
    if (cmd == "remsell") then
	LWIW_RemoveFromSellList(rmd)
	return
    end
   
    
    if ((cmd == "disable") or (cmd == "enable"))then
       LWIW_ToggleEnable(cmd)
        return
    end
    
    if (cmd == "mouseclicks") then
	LWIW_ToggleMouseClicks()
	return
    end
    if (cmd == "delete") then
        LWIW_ToggleDeletes(rmd)
        return
    end
    if (cmd == "keep") then
	LWIW_KeepCL(rmd)
	return
end
    if (cmd == "cleanup") then
      StaticPopup_Show("LWIW_DeleteBagItems")
        return
    end

    if (cmd == "autoclose") then
        LWIW_ToggleCloseWindow(rmd)
        return
    end
    
    if (cmd == "sellingoptions") then
	LWIW_ToggleSellingOptions(rmd)
	return
    end

    if (cmd == "gui") then
        InterfaceOptionsFrame_OpenToCategory(LootWhatIWant_panel)
        return
    end
    
    if (cmd == "instance") then
		if (trim(rmd) == "") then
	        LWIW_ToggleLootDungeon(GetRealZoneText())
	    else
			if (parse_truefalse(rmd)) then
				LWIW_AddLootDungeon(GetRealZoneText())
			else
				LWIW_DelLootDungeon(GetRealZoneText())
			end
		end
        return
    end
    if (cmd == "boa") then
	if (LootWhatIWant.AutoLootBOA) then
		LootWhatIWant.AutoLootBOA = false
		print("LWIW: Will NOT auto loot Bind on Battle.net Account bags")
	else
		LootWhatIWant.AutoLootBOA = true
		print("LWIW: Will now auto loot Bind on Battle.net Account bags")
	end
	return
    end
    if (cmd == "world") then
        LWIW_ToggleWorldGroupLoot(rmd)
        return
    end
    
    -- Emulate old commands with new functions
    
    if (cmd == "deletesomegrays") then
        LWIW_SetDeleteGrays(rmd)
		return
	end

    if (cmd == "deleteallgrays") then
        LWIW_ToggleGrayDeletes()
		return
	end
	
	
    LWIW_PrintUsage()
end

-- ------------------------------------------------------------------
-- Setup slash command processing
-- ------------------------------------------------------------------
SLASH_LOOTWHATIWANT1 = commandPrefix
SlashCmdList["LOOTWHATIWANT"] = function(msg)
	if( msg ) then
		local cmd, rmd = msg:match("^(%S*)%s*(.-)$")
        LWIW_ProcessChatCommand(trim(cmd), trim(rmd), trim(msg))
	end
end

LWIW_Loaded = false
--LootWhatIWant_Frame:RegisterEvent("WORLD_MAP_NAME_UPDATE")
LootWhatIWant_Frame:RegisterEvent("ADDON_LOADED")
LootWhatIWant_Frame:RegisterEvent("BAG_UPDATE")
LootWhatIWant_Frame:RegisterEvent("LOOT_OPENED")
LootWhatIWant_Frame:RegisterEvent("LOOT_BIND_CONFIRM")
LootWhatIWant_Frame:RegisterEvent("MERCHANT_SHOW")
LootWhatIWant_Frame:RegisterEvent("MERCHANT_CLOSED")
LootWhatIWant_Frame:RegisterEvent("PLAYER_LEAVE_COMBAT")
LootWhatIWant_Frame:RegisterEvent("PLAYER_ALIVE")
LootWhatIWant_Frame:RegisterEvent("PLAYER_UNGHOST")
LootWhatIWant_Frame:RegisterEvent("ITEM_LOCK_CHANGED")
LootWhatIWant_Frame:SetScript("OnEvent", LootWhatIWant_EventHandler)
--hooksecurefunc("ContainerFrameItemButton_HandleModifiedItemClick", LWIW_CointainerOnClick)
hooksecurefunc("HandleModifiedItemClick", function(itemLink, itemLocation)
    local button = GetMouseButtonClicked()
	if itemLocation and itemLocation:IsBagAndSlot() then
	
		if (button == "RightButton" and IsAltKeyDown() and IsControlKeyDown()) then
			if (LootWhatIWant.MouseClicks) then
				if (LootWhatIWant.toggleSellingStuff) then
					local link = itemLink
					if (link ~= nil) then
						LWIW_Sell(link)
					else
						print("LWIW: You clicked an empty slot, please try again.")
					end
					return
				else
					print("LWIW: Selling options not enabled, so can't add to sell list.")
				end
			else
				print("LWIW: You have not enabled mouse clicks to sell/black list items. /lwiw mouseclicks")
			end
		end
		if (button == "LeftButton" and IsControlKeyDown() and IsAltKeyDown()) then
			if (LootWhatIWant.MouseClicks) then
				local link = itemLink
				if (link ~= nil) then
					LWIW_AddToBlacklist(link)
				else
					print("LWIW: You clicked an empty slot, please try again.")
				end
				return
			else
				print("LWIW: You have not enabled mouse clicks to sell/black list items. /lwiw mouseclicks")
			end
		end
	end
end)